/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.metadata;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.metadata.MetaModel;
import ru.ispras.microtesk.model.api.metadata.MetaModelBuilder;

/**
 * The {@code MetaModelFactory} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MetaModelFactory {
  private MetaModelFactory() {}

  public static MetaModel newMetaModel() {
    final MetaModelBuilder builder = new MetaModelBuilder();

    builder.addRegister("CIA", DWORD, 1);
    builder.addRegister("GPR", WORD, 32);
    builder.addRegister("FPR", DWORD, 32);
    builder.addRegister("SPR", DWORD, 1024);
    builder.addRegister("XER", DWORD, 1);
    builder.addRegister("CSRR0", DWORD, 1);
    builder.addRegister("CSRR1", DWORD, 1);
    builder.addRegister("LR", DWORD, 1);
    builder.addRegister("CTR", DWORD, 1);
    builder.addRegister("DAC1", DWORD, 1);
    builder.addRegister("DAC2", DWORD, 1);
    builder.addRegister("DBCR0", DWORD, 1);
    builder.addRegister("DBCR1", DWORD, 1);
    builder.addRegister("DBCR2", DWORD, 1);
    builder.addRegister("DBSR", DWORD, 1);
    builder.addRegister("XER_SO", BIT, 1);
    builder.addRegister("XER_OV", BIT, 1);
    builder.addRegister("CR", WORD, 1);
    builder.addRegister("CR0", Type.CARD(4), 1);
    builder.addRegister("CR1", Type.CARD(4), 1);
    builder.addRegister("CR2", Type.CARD(4), 1);
    builder.addRegister("CR7", Type.CARD(4), 1);
    builder.addRegister("CR0_LT", BIT, 1);
    builder.addRegister("CR0_GT", BIT, 1);
    builder.addRegister("CR0_EQ", BIT, 1);
    builder.addRegister("CR0_SO", BIT, 1);

    builder.addMemory("BRANCH", BIT, 0x1);
    builder.addMemory("SKIPOP", BIT, 0x1);
    builder.addMemory("NEXTPC", DWORD, 0x1);
    builder.addMemory("MEM", WORD, 0x40000000);

    builder.addMode(R.get());
    builder.addMode(FR.get());

    builder.addOperation(nop.get());
    builder.addOperation(PowerPCNopOp.get());
    builder.addOperation(load_general.get());
    builder.addOperation(lw.get());
    builder.addOperation(store_general.get());
    builder.addOperation(sw.get());
    builder.addOperation(PowerPCMmuOp.get());
    builder.addOperation(branch_general.get());
    builder.addOperation(b.get());
    builder.addOperation(ba.get());
    builder.addOperation(bl.get());
    builder.addOperation(bla.get());
    builder.addOperation(PowerPCBpuBranch.get());
    builder.addOperation(PowerPCBpuOp.get());
    builder.addOperation(add.get());
    builder.addOperation(add_d.get());
    builder.addOperation(addo.get());
    builder.addOperation(addo_d.get());
    builder.addOperation(addi.get());
    builder.addOperation(ori.get());
    builder.addOperation(subf.get());
    builder.addOperation(subf_d.get());
    builder.addOperation(subfo.get());
    builder.addOperation(subfo_d.get());
    builder.addOperation(neg.get());
    builder.addOperation(neg_d.get());
    builder.addOperation(nego.get());
    builder.addOperation(nego_d.get());
    builder.addOperation(xor.get());
    builder.addOperation(xor_d.get());
    builder.addOperation(PowerPCArithmetic.get());
    builder.addOperation(PowerPCAluOp.get());
    builder.addOperation(Op.get());
    builder.addOperation(instruction.get());

    return builder.build();
  }
}
