/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.mmu.spec;

import ru.ispras.microtesk.basis.solver.integer.IntegerVariable;
import ru.ispras.microtesk.mmu.basis.MemoryOperation;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuAction;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuCondition;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuConditionAtom;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuGuard;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSegment;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuTransition;

/**
 * The {@code MMU} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MMU {
  public final PA pa = PA.get();

  public final IntegerVariable data;

  public final MmuAction START;
  public final MmuAction STOP;

  private final MmuAction IF_READ;

  private final MmuAction IF_WRITE;

  protected MMU(final MmuSubsystem.Builder builder) {
    this(builder, "MMU");
  }

  private MMU(final MmuSubsystem.Builder builder, final String name) {
    this.data = new IntegerVariable(name + ".data", 64);

    this.START = new MmuAction(name + ".START");
    builder.registerAction(START);
    this.STOP = new MmuAction(name + ".STOP");
    builder.registerAction(STOP);

    this.IF_READ = new MmuAction(name + ".IF_READ");
    builder.registerAction(IF_READ);
    builder.registerTransition(new MmuTransition(START, IF_READ, new MmuGuard(MemoryOperation.LOAD)));
    builder.registerTransition(new MmuTransition(IF_READ, STOP));

    this.IF_WRITE = new MmuAction(name + ".IF_WRITE");
    builder.registerAction(IF_WRITE);
    builder.registerTransition(new MmuTransition(START, IF_WRITE, new MmuGuard(MemoryOperation.STORE)));
    builder.registerTransition(new MmuTransition(IF_WRITE, STOP));
  }
}
