/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class load_general extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "load_general",
          load_general.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("DS_op", Type.CARD(14));
      addArgument("ra", R.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final Immediate DS_op = (Immediate) getArgument("DS_op", args);
      final R ra = (R) getArgument("ra", args);

      return new load_general(rd, DS_op, ra);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rd;
  public final Immediate DS_op;
  public final R ra;

  public load_general(final R rd, final Immediate DS_op, final R ra) {
    assert R.INFO.isSupported(rd);
    assert Type.CARD(14).equals(DS_op.getType());
    assert R.INFO.isSupported(ra);
    this.rd = rd;
    this.DS_op = DS_op;
    this.ra = ra;
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    ra.execute(pe__, vars__);
    if (vars__.gpr_reg_number.access().load().equals(Data.valueOf(Type.CARD(5), 0x0))) {
      vars__.temp.access().store(Data.valueOf(WORD, 0x0));
    } else {
      vars__.temp.access().store(ra.access(pe__, vars__).load());
    }
    vars__.temp1.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, DS_op.access().load().shiftLeft(Data.valueOf(Type.CARD(14), 0x2)))));
    rd.access(pe__, vars__).store(pe__.MEM.access(vars__.temp1.access().bitField(31, 2).load()).load());
  }
}