/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class lw extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "lw",
          lw.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("DS", Type.CARD(14));
      addArgument("ra", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final Immediate DS = (Immediate) getArgument("DS", args);
      final R ra = (R) getArgument("ra", args);

      return new lw(rd, DS, ra);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "lw",
          instruction.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("DS", Type.CARD(14));
      addArgument("ra", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final Immediate DS = (Immediate) getArgument("DS", args);
      final R ra = (R) getArgument("ra", args);

      return new instruction(
        new lw(
          rd,
          DS,
          ra
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rd;
  public final Immediate DS;
  public final R ra;

  public lw(final R rd, final Immediate DS, final R ra) {
    assert R.INFO.isSupported(rd);
    assert Type.CARD(14).equals(DS.getType());
    assert R.INFO.isSupported(ra);
    this.rd = rd;
    this.DS = DS;
    this.ra = ra;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x17));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("lw %s, %d(%s)", rd.syntax(vars__), DS.access().load().bigIntegerValue(), ra.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("01%14s%5s%5s%6s", DS.access().load().toString(), ra.image(vars__), rd.image(vars__), vars__.OPCD.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new load_general(rd, DS, ra).execute(pe__, vars__);
  }
}