/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class subf_d extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "subf_d",
          subf_d.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("ra", R.INFO);
      addArgument("rb", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R ra = (R) getArgument("ra", args);
      final R rb = (R) getArgument("rb", args);

      return new subf_d(rd, ra, rb);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "subf_d",
          instruction.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("ra", R.INFO);
      addArgument("rb", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R ra = (R) getArgument("ra", args);
      final R rb = (R) getArgument("rb", args);

      return new instruction(
        new subf_d(
          rd,
          ra,
          rb
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rd;
  public final R ra;
  public final R rb;

  public subf_d(final R rd, final R ra, final R rb) {
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(ra);
    assert R.INFO.isSupported(rb);
    this.rd = rd;
    this.ra = ra;
    this.rb = rb;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    vars__.Rc.access().store(Data.valueOf(BIT, 0x1));
    vars__.OE.access().store(Data.valueOf(BIT, 0x0));
    vars__.XO_9.access().store(Data.valueOf(Type.CARD(9), 0x28));
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x3e));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("subf. %s, %s, %s", rd.syntax(vars__), ra.syntax(vars__), rb.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%1s%9s%1s%5s%5s%5s%6s", vars__.Rc.access().load().toString(), vars__.XO_9.access().load().toString(), vars__.OE.access().load().toString(), rb.image(vars__), ra.image(vars__), rd.image(vars__), vars__.OPCD.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new subf_general(new Immediate(vars__.Rc.access()), new Immediate(vars__.OE.access()), rd, ra, rb).execute(pe__, vars__);
  }
}