/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.powerpc.mode.*;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class subf_general extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "subf_general",
          subf_general.class,
          null
          );
      addArgument("Rc_op", BIT);
      addArgument("OE_op", BIT);
      addArgument("rd", R.INFO);
      addArgument("ra", R.INFO);
      addArgument("rb", R.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate Rc_op = (Immediate) getArgument("Rc_op", args);
      final Immediate OE_op = (Immediate) getArgument("OE_op", args);
      final R rd = (R) getArgument("rd", args);
      final R ra = (R) getArgument("ra", args);
      final R rb = (R) getArgument("rb", args);

      return new subf_general(Rc_op, OE_op, rd, ra, rb);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate Rc_op;
  public final Immediate OE_op;
  public final R rd;
  public final R ra;
  public final R rb;

  public subf_general(final Immediate Rc_op, final Immediate OE_op, final R rd, final R ra, final R rb) {
    assert BIT.equals(Rc_op.getType());
    assert BIT.equals(OE_op.getType());
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(ra);
    assert R.INFO.isSupported(rb);
    this.Rc_op = Rc_op;
    this.OE_op = OE_op;
    this.rd = rd;
    this.ra = ra;
    this.rb = rb;
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.temp33.access().store(Location.concat(ra.access(pe__, vars__).bitField(31, 31), ra.access(pe__, vars__).bitField(31, 0)).load().not().add(Location.concat(rb.access(pe__, vars__).bitField(31, 31), rb.access(pe__, vars__).bitField(31, 0)).load()).add(Data.valueOf(Type.CARD(33), 0x1)));
    rd.access(pe__, vars__).store(vars__.temp33.access().bitField(31, 0).load());
    if (OE_op.access().load().equals(Data.valueOf(BIT, 0x1))) {
      pe__.XER_OV.access().store(vars__.temp33.access().bitField(32, 32).load().xor(vars__.temp33.access().bitField(31, 31).load()));
      pe__.XER_SO.access().store(pe__.XER_SO.access().load().or(pe__.XER_OV.access().load()));
    }
    if (Rc_op.access().load().equals(Data.valueOf(BIT, 0x1))) {
      if (rd.access(pe__, vars__).load().equals(Data.valueOf(WORD, 0x0))) {
        pe__.CR0_EQ.access().store(Data.valueOf(BIT, 0x1));
      } else if (rd.access(pe__, vars__).bitField(31, 31).load().equals(Data.valueOf(BIT, 0x1))) {
        pe__.CR0_LT.access().store(Data.valueOf(BIT, 0x1));
      } else {
        pe__.CR0_GT.access().store(Data.valueOf(BIT, 0x1));
      }
      pe__.CR0_SO.access().store(pe__.XER_SO.access().load());
    }
  }
}