/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.powerpc.mode.*;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class xor_general extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "xor_general",
          xor_general.class,
          null
          );
      addArgument("Rc_op", BIT);
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("rb", R.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate Rc_op = (Immediate) getArgument("Rc_op", args);
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final R rb = (R) getArgument("rb", args);

      return new xor_general(Rc_op, ra, rs, rb);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate Rc_op;
  public final R ra;
  public final R rs;
  public final R rb;

  public xor_general(final Immediate Rc_op, final R ra, final R rs, final R rb) {
    assert BIT.equals(Rc_op.getType());
    assert R.INFO.isSupported(ra);
    assert R.INFO.isSupported(rs);
    assert R.INFO.isSupported(rb);
    this.Rc_op = Rc_op;
    this.ra = ra;
    this.rs = rs;
    this.rb = rb;
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    ra.access(pe__, vars__).store(rs.access(pe__, vars__).load().xor(rb.access(pe__, vars__).load()));
    if (Rc_op.access().load().equals(Data.valueOf(BIT, 0x1))) {
      if (ra.access(pe__, vars__).load().equals(Data.valueOf(WORD, 0x0))) {
        pe__.CR0_EQ.access().store(Data.valueOf(BIT, 0x1));
      } else if (ra.access(pe__, vars__).bitField(31, 31).load().equals(Data.valueOf(BIT, 0x1))) {
        pe__.CR0_LT.access().store(Data.valueOf(BIT, 0x1));
      } else {
        pe__.CR0_GT.access().store(Data.valueOf(BIT, 0x1));
      }
      pe__.CR0_SO.access().store(pe__.XER_SO.access().load());
    }
  }
}